
\section{Conclusions\label{sec:conclusions}}

We have presented five approaches to implementing domain-specific languages (DSLs)
in Scala, illustrated by application to formal modeling and testing languages. External DSLs use either (1) a parser generator, or (2) a parser library.
Internal DSLs extend the host language by (3) annotations
of existing language elements, (4) deep
embedding where an abstract representation of the program is computed, or
(5) shallow embedding of functions that directly execute.
%
Our experience shows that each approach has its strengths; in particular,
external DSLs can offer a fully flexible syntax while internal DSLs are
easier to develop and in the case of shallow embedding, are directly executable.
Mixed approaches are common, in particular for internal DSLs.
Future work includes leveraging macro-based and compiler-based approaches,
which promise to combine some of the strengths of the techniques discussed here.
